;;; bounded-stack-and-queue.scm  -- Jens Axel Sgaard

(module bounded-stack-and-queue mzscheme
  (provide insert! remove! (rename make-empty-bounded-collection make-empty))
  
  (require (lib "match.ss" "mzlib"))
  
  (define-struct bounded-collection (stack/queue elements size first))
  
  (define (make-empty-bounded-collection type n)
    (make-bounded-collection type (make-vector n '()) 0 0))
  
  (define (insert! BC x)
    (match BC
      [($ bounded-collection 'stack elements size _)
       (vector-set! elements size x)
       (set-bounded-collection-size! BC (add1 size))]
      [($ bounded-collection 'queue elements size first)
       (let ([len (vector-length elements)])
         (vector-set! elements (modulo (+ size first) len) x)
         (set-bounded-collection-size! BC (add1 size)))]))
  
  (define (remove! BC)
    (match BC
      [($ bounded-collection 'stack elements size _)
       (begin0
         (vector-ref elements (sub1 size))
         (set-bounded-collection-size! BC (sub1 size)))]
      [($ bounded-collection 'queue elements size first)
       (let ([len (vector-length elements)])
         (begin0
           (vector-ref elements first)
           (set-bounded-collection-first! BC (modulo (add1 first) len))
           (set-bounded-collection-size! BC (sub1 size))))]))
  )

